Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bugzilla DB migration completed. Please report issues to Infra team via email via infra@gentoo.org or IRC
Bug 373341 - env-update shall pass '-X' to ldconfig in order not to update SONAME symlinks
Summary: env-update shall pass '-X' to ldconfig in order not to update SONAME symlinks
Status: RESOLVED FIXED
Alias: None
Product: Portage Development
Classification: Unclassified
Component: Core (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Portage team
URL:
Whiteboard:
Keywords: InVCS
: 364431 (view as bug list)
Depends on: 373343
Blocks: 364431 373933
  Show dependency tree
 
Reported: 2011-06-28 13:55 UTC by Michał Górny
Modified: 2012-04-29 07:51 UTC (History)
1 user (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
A patch for portage (0001-Don-t-ever-recreate-root-.so-links-on-env-update.patch,1.73 KB, patch)
2011-06-28 13:55 UTC, Michał Górny
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Michał Górny archtester Gentoo Infrastructure gentoo-dev Security 2011-06-28 13:55:34 UTC
Created attachment 278483 [details, diff]
A patch for portage

As explained on gentoo-dev [1], env-update should pass '-X' to ldconfig in order to preserve SONAME symlinks installed by portage. This fixes downgrade issues with preserved-libs.

Opening a bug to track other 'ldconfig' calls.

[1]:http://archives.gentoo.org/gentoo-dev/msg_7eb376c69be3e43ce8847586cd36de1e.xml
Comment 1 Zac Medico gentoo-dev 2011-06-28 14:39:02 UTC
Maybe we should add a pre-merge symlink check for $D. Then if necessary we can generate missing symlinks and trigger a QA Notice.
Comment 2 Michał Górny archtester Gentoo Infrastructure gentoo-dev Security 2011-06-28 14:48:27 UTC
(In reply to comment #1)
> Maybe we should add a pre-merge symlink check for $D. Then if necessary we can
> generate missing symlinks and trigger a QA Notice.

Well, I did a massive 'qlist -a' check on my packages and none seem not to provide those symlinks. But such a check is a good idea indeed. Even better than blindly running 'ldconfig -N -n ${D}/usr/lib'.
Comment 3 Zac Medico gentoo-dev 2011-06-29 09:33:07 UTC
I've made it automatically create symlinks after src_install, since that's when NEEDED.ELF.2 is generated:

http://git.overlays.gentoo.org/gitweb/?p=proj/portage.git;a=commit;h=31c9c68d7e96070166fe385141400fa3bcb5950e

And the env-update patch is applied:

http://git.overlays.gentoo.org/gitweb/?p=proj/portage.git;a=commit;h=e1347f9c0dd5ef5ff1a50d6b136b0648efb8a6ca
Comment 4 Zac Medico gentoo-dev 2011-06-30 03:40:00 UTC
(In reply to comment #3)
> I've made it automatically create symlinks after src_install, since that's when
> NEEDED.ELF.2 is generated:
> 
> http://git.overlays.gentoo.org/gitweb/?p=proj/portage.git;a=commit;h=31c9c68d7e96070166fe385141400fa3bcb5950e

This is confined to global libdirs now:

http://git.overlays.gentoo.org/gitweb/?p=proj/portage.git;a=commit;h=cad462a63a79438f1666b41a61631de2de4a6163
Comment 5 Zac Medico gentoo-dev 2011-07-01 05:09:06 UTC
This is in 2.2.0_alpha42, but I'll leave this bug open until it's in an unmasked release.
Comment 6 Zac Medico gentoo-dev 2011-07-03 17:36:01 UTC
This is fixed in 2.1.10.4.
Comment 7 Zac Medico gentoo-dev 2012-04-29 07:51:31 UTC
*** Bug 364431 has been marked as a duplicate of this bug. ***